<?php
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

	//Loading global settings
	$query = "SELECT name, value FROM #__flippingbook_config";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	$rows = $database->loadObjectList();
	foreach ( $rows as $row ) {
		eval ('$FB_' . $row->name . " = '" . $row->value . "';");
	}
	
if (file_exists($mosConfig_absolute_path.'/administrator/components/com_flippingbook/language/' . $FB_language)) {
	include_once($mosConfig_absolute_path.'/administrator/components/com_flippingbook/language/' . $FB_language);
} else {
	if (file_exists($mosConfig_absolute_path.'/administrator/components/com_flippingbook/language/english.php')) {
		include_once($mosConfig_absolute_path.'/administrator/components/com_flippingbook/language/english.php');
	}
}

require_once($mainframe->getPath('admin_html')); 
require_once($mosConfig_absolute_path."/administrator/components/com_flippingbook/class.flippingbook.php");


define( 'COM_MEDIA_BASE', $mosConfig_absolute_path . DIRECTORY_SEPARATOR . 'images' . DIRECTORY_SEPARATOR . 'flippingbook' );
define( 'COM_MEDIA_BASEURL', $mosConfig_live_site . '/images' );

/* Old Joomla version */
if (!function_exists( 'josGetArrayInts' )) {

   $cid = mosGetParam( $_POST, 'cid', array(0) );

  	if (is_array( $cid )) {
  		$n = count( $cid );
  		for ($i = 0; $i < $n; $i++) {
  			$cid[$i] = intval( $cid[$i] );
  		}
  	} else {
      $cid = array(0);
   }

  } else {
    /* Joomla 1.0.11 */
    $cid = josGetArrayInts( 'cid' );
}
		
switch ($task) {
	case 'main':
		doMainPage();
	break;
	case 'remove':
		switch ($act) {
			case 'books':
				removeBook( $cid, $option );
			break;
			case 'pages':
				removePage( $cid, $option );
			break;
		}
	break;
	case 'edit':
		switch ($act) {
			case 'books':
				doEditBook();
			break;
			case 'pages':
				doEditPage();
			break;
		}
	break;
	case 'orderdown':
		switch ($act) {
			case 'books':
				orderBooks( intval( $cid[0] ), 1, $option );
			break;
			case 'pages':
				orderPages( intval( $cid[0] ), 1, $option );
			break;
		}
	break;
	case 'orderup':
		switch ($act) {
			case 'books':
				orderBooks( intval( $cid[0] ), -1, $option );
			break;
			case 'pages':
				orderPages( intval( $cid[0] ), -1, $option );
			break;
		}
	break;
	case 'saveorder':
		saveOrder( $cid );
	break;
	case 'upload':
		doUpload();
	break;
	case 'save_uploaded';
		doSaveUploaded();
	break;
	case 'delete_file';
		doDeleteFile();
	break;
	case 'manage_books':
		doBooks($option);
	break;
	case 'new_book':
		doNewBook();
	break;
	case 'save_book':
		doSaveBook();
	break;
	case 'cancel_book':
		doBooks($option);
	break;
	case 'edit_book':
		doEditBook();
	break;
	case 'publish_book':
		doPublishBook();
	break;
	case 'unpublish_book':
		doUnpublishBook();
	break;
	case 'manage_pages':
		doPages($option);
	break;
	case 'new_page':
		doNewPage();
	break;
	case 'save_page':
		doSavePage();
	break;
	case 'edit_page':
		doEditPage();
	break;
	case 'cancel_page':
		doPages($option);
	break;
	case 'publish_page':
		doPublishPage();
	break;
	case 'unpublish_page':
		doUnpublishPage();
	break;
	case 'save_config':
		doSaveConfig();
	break;
	case 'cancel_config':
		doMainPage();
	break;
	case 'config':
		doConfig();
	break;
	case 'files':
		doFiles($option);
	break;
	case 'rename_file':
		doRenameFile();
	break;
	case 'save_file_name':
		doSaveFileName();
	break;
	default:
		switch ($act) {
			case 'config':
				doConfig();
			break;
			case 'manage_books':
				doBooks($option);
			break;
			case 'manage_pages':
				doPages($option);
			break;
			case 'upload':
				doUpload();
			break;
			case 'files':
				doFiles($option);
			break;
			default:
				doMainPage();
			break;
			}
	break;
}

function doMainPage() {
	global $option;
	HTML_flippingbook::MainPage($option, $files);
}

function doUpload() {
	global $option;
	HTML_flippingbook::Upload($option);
}

function doSaveUploaded() {
	global $clearUploads;
	$file = $_FILES['upload'];
	$dest_dir = COM_MEDIA_BASE . '/';

	if (file_exists($dest_dir.$file['name'])) {
		mosRedirect( "index2.php?option=com_flippingbook", _FB_UPLOAD_FAILED );
	}
	$format = substr( $file['name'], -3 );
	$allowable = array ('jpg', 'jpeg', 'png', 'gif', 'bmp', 'swf', 'mp3');
	$noMatch = 0;
	foreach( $allowable as $ext ) {
		if ( strcasecmp( $format, $ext ) == 0 ) {
			$noMatch = 1;
		}
	}
	if(!$noMatch){
		mosRedirect( "index2.php?option=com_flippingbook&act=upload", _FB_INVALID_FILE_TYPE );
	}
	if (!move_uploaded_file($file['tmp_name'], $dest_dir.strtolower($file['name']))){
		mosRedirect( "index2.php?option=com_flippingbook&act=upload", _FB_CHECK_RIGHTS );
	} else {
		mosChmod($dest_dir.strtolower($file['name']));
		mosRedirect( "index2.php?option=com_flippingbook&act=upload", _FB_UPLOAD_SUCCESS );
	}
	$clearUploads = true;
}

function doFiles($option) {
	global $mosConfig_absolute_path;
	
	$imagesBaseDir = mosPathName( $mosConfig_absolute_path . '/images/flippingbook' );
	$allFiles = mosReadDirectory($imagesBaseDir);
	HTML_flippingbook::manageFiles($option, $allFiles);
}

function doDeleteFile() {
	global $option, $database, $mosConfig_absolute_path;
	$file_names = mosGetParam( $_POST, 'file', '' );
	$files = implode( "','", $file_names );
	$files = "'" . $files . "'";
	$query = "SELECT * FROM #__flippingbook_pages"
		. "\n WHERE file IN ( $files )";
	$database->setQuery($query);
	$rows = $database->loadObjectList();
	$query = "SELECT * FROM #__flippingbook_books"
		. "\n WHERE image IN ( $files )";
	$database->setQuery($query);
	$rows2 = $database->loadObjectList();
	$query = "SELECT * FROM #__flippingbook_books"
		. "\n WHERE bg_image IN ( $files )";
	$database->setQuery($query);
	$rows3 = $database->loadObjectList();
	if ((count($rows) > 0)||((count($rows2) > 0))||((count($rows3) > 0))) {
		mosRedirect( "index2.php?option=com_flippingbook&act=files", _FB_DELET_FAILED );
	} else {
		foreach ($file_names as $fileName) {
			unlink ($mosConfig_absolute_path . "/images/flippingbook/" . $fileName);
		}
		mosRedirect( "index2.php?option=com_flippingbook&act=files", _FB_FILE_DELETED );
	}
}

function doRenameFile() {
	global $option, $database;
	$file_name = mosGetParam( $_GET, 'file_to_rename', '' );

	$files = "'" . $file_name . "'";
	$query = "SELECT * FROM #__flippingbook_pages"
		. "\n WHERE file IN ( $files )";
	$database->setQuery($query);
	$rows = $database->loadObjectList();
	$query = "SELECT * FROM #__flippingbook_books"
		. "\n WHERE image IN ( $files )";
	$database->setQuery($query);
	$rows2 = $database->loadObjectList();
	$query = "SELECT * FROM #__flippingbook_books"
		. "\n WHERE bg_image IN ( $files )";
	$database->setQuery($query);
	$rows3 = $database->loadObjectList();
	if ((count($rows) > 0)||((count($rows2) > 0))||((count($rows3) > 0))) {
		mosRedirect( "index2.php?option=com_flippingbook&act=files", _FB_RENAME_ERROR);
	} else {
		
			HTML_flippingbook::RenameFile($option, $file_name);
	}
}

function doSaveFileName() {
	global $database, $mosConfig_absolute_path;
	$old_file_name = mosGetParam( $_POST, 'old_file_name', '' );
	$new_file_name = mosGetParam( $_POST, 'new_file_name', '' );
	if (preg_match('/\.(php|php3|php4|php5|php6|js|htm|html|phtml|cgi|pl|perl|asp)$/i', $new_file_name)) {
		mosRedirect( "index2.php?option=com_flippingbook&act=files", _FB_RENAME_ERROR_INCORRECT_NAME);
	} else {
		$old = $mosConfig_absolute_path . '/images/flippingbook/'. $old_file_name;
		$new = $mosConfig_absolute_path . '/images/flippingbook/'. $new_file_name;
		if (@rename ($old, $new)) {
			mosRedirect( "index2.php?option=com_flippingbook&act=files", _FB_FILE  . ' ' . $old_file_name . _FB_RENAMED_TO . $new_file_name);
		} else {
			echo "<script> alert('" . _FB_INCORRECT_FILE_NAME . "'); window.history.go(-1); </script>\n";
		}
	}
}

function removeBook( &$cid, $option ) {
	global $database;

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$query = "DELETE FROM #__flippingbook_books"
		. "\n WHERE id IN ( $cids )";
		$database->setQuery( $query );
		if (!$database->query()) {
			echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		$query = "DELETE FROM #__flippingbook_pages"
		. "\n WHERE book_id IN ( $cids )";
		$database->setQuery( $query );
		if (!$database->query()) {
			echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}
	$row = new flippingbook_book( $database );
	$row->updateOrder();
	mosRedirect( "index2.php?option=com_flippingbook&act=manage_books", _FB_BOOK_REMOVED );
}

function removePage( $cid, $option ) {
	global $database;
	
	$cids = implode( ',', $cid );
	$query = "DELETE FROM #__flippingbook_pages"
	. "\n WHERE id IN ( $cids )";
	$database->setQuery( $query );
	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
	}
	mosRedirect( "index2.php?option=com_flippingbook&act=manage_pages", _FB_PAGE_REMOVED );
}

function doConfig() {
	global $option, $database;
	
	$query = "SELECT name, value FROM #__flippingbook_config";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	$rows = $database->loadObjectList();
		
	HTML_flippingbook::showConfig($option, $rows);
}

function doSaveConfig() {
	global $option, $database;
	
	$FB_preview_width = mosGetParam( $_POST, 'preview_width', '' );
	$FB_preview_height = mosGetParam( $_POST, 'preview_height', '' );
	$FB_firstPage = mosGetParam( $_POST, 'firstPage', '' );
	$FB_flipSound = mosGetParam( $_POST, 'flipSound', '' );
	$FB_cacheSize = mosGetParam( $_POST, 'cacheSize', '' );
	$FB_closeSpeed = mosGetParam( $_POST, 'closeSpeed', '' );
	$FB_moveSpeed = mosGetParam( $_POST, 'moveSpeed', '' );
	$FB_preloaderType = mosGetParam( $_POST, 'preloaderType', '' );
	$FB_flipOnClick = mosGetParam( $_POST, 'flipOnClick', '' );
	$FB_scaleContent = mosGetParam( $_POST, 'scaleContent', '' );
	$FB_loadOnDemand = mosGetParam( $_POST, 'loadOnDemand', '' );
	$FB_cachePages = mosGetParam( $_POST, 'cachePages', '' );
	$FB_alwaysOpened = mosGetParam( $_POST, 'alwaysOpened', '' );
	$FB_bookListTitle = mosGetParam( $_POST, 'bookListTitle', '' );
	$FB_showDescription = mosGetParam( $_POST, 'showDescription', '' );
	$FB_showBookName = mosGetParam( $_POST, 'showBookName', '' );
	$FB_showNavigation = mosGetParam( $_POST, 'showNavigation', '' );
	$FB_bgColor = mosGetParam( $_POST, 'bgColor', '' );
	$FB_style = mosGetParam( $_POST, 'style', '' );
	$FB_language = mosGetParam( $_POST, 'language', '' );
	$FB_columns = mosGetParam( $_POST, 'columns', '' );
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_preview_width'
		WHERE name = 'preview_width'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_preview_height'
		WHERE name = 'preview_height'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_firstPage'
		WHERE name = 'firstPage'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());	
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_flipSound'
		WHERE name = 'flipSound'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_cacheSize'
		WHERE name = 'cacheSize'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_closeSpeed'
		WHERE name = 'closeSpeed'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());

	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_moveSpeed'
		WHERE name = 'moveSpeed'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_preloaderType'
		WHERE name = 'preloaderType'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_flipOnClick'
		WHERE name = 'flipOnClick'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_scaleContent'
		WHERE name = 'scaleContent'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_loadOnDemand'
		WHERE name = 'loadOnDemand'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_cachePages'
		WHERE name = 'cachePages'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_alwaysOpened'
		WHERE name = 'alwaysOpened'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
		
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_bookListTitle'
		WHERE name = 'bookListTitle'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
				
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_showDescription'
		WHERE name = 'showDescription'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
			
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_showBookName'
		WHERE name = 'showBookName'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_showNavigation'
		WHERE name = 'showNavigation'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_bgColor'
		WHERE name = 'bgColor'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());	
	
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_style'
		WHERE name = 'style'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
		
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_language'
		WHERE name = 'language'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
		
	$query = "UPDATE #__flippingbook_config
		SET value = '$FB_columns'
		WHERE name = 'columns'";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	
	mosRedirect( "index2.php?option=com_flippingbook", _FB_CONFIGURATION_SAVED );
}

function doBooks($option) {
	global $database, $mainframe, $mosConfig_list_limit;
	
	$catid 		= intval( $mainframe->getUserStateFromRequest( "catid{$option}", 'catid', 0 ) );
	$limit 		= intval( $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit ) );
	$limitstart = intval( $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 ) );
	$search 	= $mainframe->getUserStateFromRequest( "search{$option}", 'search', '' );
	$search 	= $database->getEscaped( trim( strtolower( $search ) ) );
	
	$query = "SELECT COUNT(*)"
	. "\n FROM #__flippingbook_books";
	$database->setQuery( $query );
	$total = $database->loadResult();

	require_once( $GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit  );
	
	$query = "SELECT * FROM #__flippingbook_books
		ORDER BY ordering";
		
	$database->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $database->loadObjectList();

	HTML_flippingbook::showBooks( $rows, $pageNav, $search, $option);
}

function doPages($option) {
	global $database, $mainframe, $mosConfig_list_limit;
	
	$catid 		= intval( $mainframe->getUserStateFromRequest( "catid{$option}", 'catid', 0 ) );
	$limit 		= intval( $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit ) );
	$limitstart = intval( $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 ) );
	$search 	= $mainframe->getUserStateFromRequest( "search{$option}", 'search', '' );
	$search 	= $database->getEscaped( trim( strtolower( $search ) ) );
	if (mosGetParam( $_POST, 'book_id_filter', '' ) != '') $book_id_filter = mosGetParam( $_POST, 'book_id_filter', '' );
	if (mosGetParam( $_GET, 'book_id_filter', '' ) != '') $book_id_filter = mosGetParam( $_GET, 'book_id_filter', '' );
	if ($book_id_filter > 0) {
		$where = 'AND p.book_id = ' . $book_id_filter;
	} else {
		$where = '';
	}
	
	$query = "SELECT COUNT(*)"
	. "\n FROM #__flippingbook_pages";
	$database->setQuery( $query );
	$total = $database->loadResult();

	require_once( $GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit  );
	
	$query = "SELECT p.id, p.file, p.published, p.ordering, p.book_id, b.name 
		FROM #__flippingbook_pages p, #__flippingbook_books b 
		WHERE p.book_id = b.id " . $where . " 
		ORDER BY p.book_id, p.ordering";
	
	$database->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $database->loadObjectList();
	
	$database->setQuery( "SELECT id, name 
		FROM #__flippingbook_books
		ORDER BY name" );
    $dbBooks = $database->loadObjectList();
	
	$blist = '<select name="book_id_filter" class="inputbox" onchange="document.adminForm.submit();">
		<option value="">' . _FB_SHOW_ALL_BOOKS . '</option>';
	foreach ($dbBooks as $book) {
				$blist .= '<option value="' . $book->id . '"';
				if ($book_id_filter == $book->id) $blist .= ' selected="selected"';
				$blist .= '>' . $book->name . "</option>";
	}
	$blist .= '</select>';
	
	HTML_flippingbook::showPages( $rows, $pageNav, $search, $option, $blist, $book_id_filter );
}

function doNewBook() {
	global $option, $mosConfig_absolute_path;
	
	$imagesBaseDir = mosPathName( $mosConfig_absolute_path . '/images/flippingbook' );
	$imagesFiles = mosReadDirectory($imagesBaseDir);
	
	$filesHTML = '<select name="image" class="inputbox" >
		<option value=""></option>';
		foreach ($imagesFiles as $file) {
			if (preg_match('/\.(gif|jpg|bmp|png|jpeg)$/i', $file)) {
				$filesHTML .= '<option value="' . $file . '">' . $file . "</option>";
			}
		}
	$filesHTML .= '</select> ';

	$files_bg_HTML = '<select name="bg_image" class="inputbox" >
	<option value=""></option>';
		foreach ($imagesFiles as $file) {
			if (preg_match('/\.(gif|jpg|bmp|png|jpeg)$/i', $file)) {
				$files_bg_HTML .= '<option value="' . $file . '">' . $file . "</option>";
			}
		}
	$filesHTML .= '</select> ';
	HTML_flippingbook::addBook($option, $filesHTML, $files_bg_HTML);
}

function doSaveBook() {
	global $option, $database;
	
	$row = new flippingbook_book( $database );
	
	if (!$row->bind( $_POST )) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	$row->updateOrder();
	
	mosRedirect( "index2.php?option=com_flippingbook&act=manage_books", _FB_BOOK_SAVED );

}

function doSavePage() {
	global $option, $database;
	
	$redirect = mosGetParam( $_POST, 'book_id_filter', 0 );
	$book_id = mosGetParam( $_POST, 'book_id', '' );
	$row = new flippingbook_page( $database );
	
	if (!$row->bind( $_POST )) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	
	$row->updateOrder("book_id = $row->book_id");
	
	mosRedirect( "index2.php?option=com_flippingbook&act=manage_pages&book_id_filter=".$book_id, _FB_PAGE_SAVED );
}

function doEditBook() {
	global $cid, $option, $mosConfig_absolute_path, $database;
	if (mosGetParam( $_GET, 'book_id', '' ) != '') $cid[0] = mosGetParam( $_GET, 'book_id', '' );
	$query = "SELECT * FROM #__flippingbook_books
	WHERE id = $cid[0]";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	$rows = $database->loadObjectList();
	
	$imagesBaseDir = mosPathName( $mosConfig_absolute_path . '/images/flippingbook' );
	$imagesFiles = mosReadDirectory($imagesBaseDir);
	
	$filesHTML = '<select name="image" class="inputbox" >
		<option value=""></option>';
		foreach ($imagesFiles as $file) {
			if (preg_match('/\.(gif|jpg|bmp|png|jpeg)$/i', $file)) {
				$filesHTML .= '<option value="' . $file . '"';
				if ($rows[0]->image == $file) $filesHTML .= ' selected="selected"';
				$filesHTML .= '>' . $file . "</option>";
			}
		}
	$filesHTML .= '</select> ';

	$files_bg_HTML = '<select name="bg_image" class="inputbox" >
	<option value=""></option>';
		foreach ($imagesFiles as $file) {
			if (preg_match('/\.(gif|jpg|bmp|png|jpeg)$/i', $file)) {
				$files_bg_HTML .= '<option value="' . $file . '"';
				if ($rows[0]->bg_image == $file) $files_bg_HTML .= ' selected="selected"';
				$files_bg_HTML .= '>' . $file . "</option>";
			}
		}
	$filesHTML .= '</select> ';
	
	HTML_flippingbook::editBook($option, $rows, $filesHTML, $files_bg_HTML);
}

function doEditPage() {
	global $cid, $option, $mosConfig_absolute_path, $database;
	if (mosGetParam( $_GET, 'page_id', '' ) != '') $cid[0] = mosGetParam( $_GET, 'page_id', '' );
	$query = "SELECT * FROM #__flippingbook_pages
	WHERE id = $cid[0]";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	$rows = $database->loadObjectList();
	
	$imagesBaseDir = mosPathName( $mosConfig_absolute_path . '/images/flippingbook' );
	$imagesFiles = mosReadDirectory($imagesBaseDir);
	
	$filesHTML = '<select name="file" class="inputbox" >
		<option value=""></option>';
		foreach ($imagesFiles as $file) {
			if (preg_match('/\.(jpg|jpeg|swf)$/i', $file)) {
				$filesHTML .= '<option value="' . $file . '"';
				if ($rows[0]->file == $file) $filesHTML .= ' selected="selected"';
				$filesHTML .= '>' . $file . "</option>";
			}
		}
	$filesHTML .= '</select> ';
	
	$query = "SELECT * FROM #__flippingbook_books";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	$rows2 = $database->loadObjectList();
	
	$booksHTML = '<select name="book_id" class="inputbox" >';
	foreach ($rows2 as $row2) {
		$booksHTML .= '<option value="' . $row2->id . '"';
		if ($rows[0]->book_id == $row2->id) $booksHTML .= ' selected="selected"';
		$booksHTML .= '>' . $row2->name . "</option>";
	}
	$booksHTML .= '</select> ';
	
	HTML_flippingbook::editPage($option, $rows, $filesHTML, $booksHTML);
}

function doPublishBook() {
	global $option, $database;
	$book_id = mosGetParam( $_GET, 'book_id', '' );
	$query = "UPDATE #__flippingbook_books
	SET published = 1
	WHERE id = $book_id";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	mosRedirect( 'index2.php?option=com_flippingbook&act=manage_books' );
}

function doUnpublishBook() {
	global $option, $database;
	$book_id = mosGetParam( $_GET, 'book_id', '' );
	$query = "UPDATE #__flippingbook_books
	SET published = 0
	WHERE id = $book_id";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	mosRedirect( 'index2.php?option=com_flippingbook&act=manage_books' );
}

function doPublishPage() {
	global $option, $database;
	$page_id = mosGetParam( $_GET, 'page_id', '' );
	$query = "UPDATE #__flippingbook_pages
	SET published = 1
	WHERE id = $page_id";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	doPages($option);
}

function doUnpublishPage() {
	global $option, $database;
	$page_id = mosGetParam( $_GET, 'page_id', '' );
	$query = "UPDATE #__flippingbook_pages
	SET published = 0
	WHERE id = $page_id";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	doPages($option);
}

function orderBooks( $uid, $inc, $option ) {
	global $database;

	$row = new flippingbook_book( $database );
	$row->load( (int)$uid );
	$row->updateOrder();
	$row->move( $inc, "published >= 0" );
	$row->updateOrder();

	doBooks($option);
}

function orderPages( $uid, $inc, $option ) {
	global $database;

	$row = new flippingbook_page( $database );
	$row->load( (int)$uid );
	$row->move( $inc, "book_id = $row->book_id" );
	$row->updateOrder("book_id = $row->book_id");
	
	if (mosGetParam( $_POST, 'book_id_filter', '' ) != '') $book_id_filter = mosGetParam( $_POST, 'book_id_filter', '' );
	if (mosGetParam( $_GET, 'book_id_filter', '' ) != '') $book_id_filter	= mosGetParam( $_GET, 'book_id_filter', '' );
	mosRedirect( 'index2.php?option='. $option .'&act=manage_pages&book_id_filter='. $book_id_filter );
}

function saveOrder( &$cid ) {
	global $database;

	$total		= count( $cid );
	$redirect 	= mosGetParam( $_POST, 'book_id_filter', 0 );
	$order 		= josGetArrayInts( 'order' );
	$row 		= new flippingbook_page( $database );
	$conditions = array();

	for( $i=0; $i < $total; $i++ ) {
	echo $cid[$i].'<br>';
		$row->load( (int) $cid[$i] );
		if ($row->ordering != $order[$i]) {
			$row->ordering = $order[$i];
			if (!$row->store()) {
				echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			}
		$condition = "book_id = $row->book_id";
			$found = false;
			foreach ( $conditions as $cond )
				if ($cond[1]==$condition) {
					$found = true;
					break;
				}
			if (!$found) $conditions[] = array($row->id, $condition);
		}
	}
	foreach ( $conditions as $cond ) {
		$row->load( $cond[0] );
		$row->updateOrder( $cond[1] );
	}
	mosRedirect( 'index2.php?option=com_flippingbook&act=manage_pages&book_id_filter='. $redirect, 'Order saved' );
}

function doNewPage() {
	global $option, $database, $mosConfig_absolute_path;
	$imagesBaseDir = mosPathName( $mosConfig_absolute_path . '/images/flippingbook' );
	$imagesFiles = mosReadDirectory($imagesBaseDir);
	
	$filesHTML = '<select name="file" class="inputbox" >';
		foreach ($imagesFiles as $file) {
			if (preg_match('/\.(jpg|jpeg|swf)$/i', $file)) {
				$filesHTML .= '<option value="' . $file . '"';
				$filesHTML .= '>' . $file . "</option>";
			}
		}
	$filesHTML .= '</select> ';
	
	$query = "SELECT * FROM #__flippingbook_books";
	$database->setQuery($query);
	$database->query() or die($database->stderr());
	$rows = $database->loadObjectList();
	
	$booksHTML = '<select name="book_id" class="inputbox" >';
	foreach ($rows as $row) {
		$booksHTML .= '<option value="' . $row->id . '"';
		$booksHTML .= '>' . $row->name . "</option>";
	}
	$booksHTML .= '</select> ';

	HTML_flippingbook::addPage($option, $filesHTML, $booksHTML);
}
?>